<?php

/**
 * @file
 */

function uc_payfast_complete($cart_id = 0) {

  if (variable_get('uc_payfast_mode', '') == 'sandbox') {
    define('SANDBOX', true);
  }
  else define('SANDBOX', false);
 
  // Variable Initialization
  $pmtToken = isset( $_GET['pt'] ) ? $_GET['pt'] : null;
  
  if(!empty($pmtToken)) {
  	
    // Variable Initialization
    $error = false;
    $authToken = variable_get('uc_payfast_pdt_key', '');
    
    $req = 'pt='. $pmtToken .'&at='. $authToken;
    $data = array();
    $host = SANDBOX ? 'sandbox.payfast.co.za' : 'www.payfast.co.za';
 
    // Construct Header
    $header = "POST /eng/query/fetch HTTP/1.0\r\n";
    $header .= 'Host: '. $host ."\r\n";
    $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
    $header .= 'Content-Length: '. strlen( $req ) ."\r\n\r\n";
    
    // Connect to server
    $socket = fsockopen( 'ssl://'. $host, 443, $errno, $errstr, 10 );
      
    if(!$socket) {          	
      $error = true;
      watchdog('payfast', 'Order payment may have been completed, but RunwaySale could not contact Payfast to confirm. 
        PMT Token: !pmt-token 
        ERRNO: !errno 
        ERRSTR: !errstr', 
        array(
          '!pmt-token' => $_GET['pt'],
          '!errno' => $errno, 
          '!errstr' => $errstr
          ) 
      );

      $return = '<p>We are having trouble confirming your order. Please <a href="/cart/payfast/complete?pt='.$_GET['pt'].'">try again</a></p>';
      $return .= '<p>If the problem persists please <a href="/contact-us">contact us</a> with your order number</p>'; 
      return $return;
    }
 
    // Get data from server
    if(!$error) {
    
    	// Send command to server
        fputs($socket, $header . $req);
        
        // Read the response from the server
        $res = '';
        $headerDone = false;
 
        while(!feof($socket)) {
            $line = fgets($socket, 1024);
            //print $line;
            
            // Check if we are finished reading the header yet
            if(strcmp($line, "\r\n") == 0) {
              // read the header
              $headerDone = true;
            }
            // If header has been processed
            else if($headerDone) {
              // Read the main response
              $res .= $line;
            }
        }
 
        // Parse the returned data
        $lines = explode( "\n", $res );   
        //npa($lines);    
    }
 
    // Interpret the response from server
    if(!$error) {
      $result = trim($lines[0]);
      
      // If the transaction was successful
      if(strcmp($result, 'SUCCESS') == 0 ) {
      
      	// Process the reponse into an associative array of data
        for( $i = 1; $i < count($lines); $i++ ) {
          list( $key, $val ) = explode( "=", $lines[$i] );
          $data[urldecode( $key )] = stripslashes( urldecode( $val ) );
        }
      }
      // If the transaction was NOT successful
      else if(strcmp( $result, 'FAIL') == 0) {
        //Log for investigation
        $error = true;
        
        $pfOrderId = explode('=', $lines[1]);
        $pfOrderId = (int)$pfOrderId[1];
        
        $pfPayfastTransactionId = explode('=', $lines[2]); 
        $pfPayfastTransactionId = (int)$pfPayfastTransactionId[1];
                        
        watchdog('payfast', 
          'Payfast reports that this payment transaction FAILED. 
          PMT Token: '.$_GET['pt'].' | Order Number: '.$pfOrderId.' | Payfast Transaction ID: '.$pfPayfastTransactionId );

        $return = '<p>Your payment transaction appears to have FAILED. You may <a href="/cart">try again.</a></p>';
        $return .= '<p>If you think this is incorrect or have any questions please <a href="/contact-us">contact us</a>.</p>'; 
        $return .= '<p>You should also check your account transaction history to confirm that the payment did not go through.</p>';
        return $return;
      }
    }
 
    //// Process the payment
    if(!$error) {
      // Get the data from the new array as needed
      ///$nameFirst = $data['name_first'];
      ////$nameLast = $data['name_last'];
      ////$amountGross = $data['amount_gross'];

      // Once you have access to this data, you should perform a number of
      // checks to ensure the transaction is "correct" before processing it.
      // - Check the payment_status is Completed
      // - Check the pf_transaction_id has not already been processed
      // - Check the merchant_id is correct for your account

      // Process payment
      
      $order = uc_order_load( $data['m_payment_id']	);
      //npa($order);
      
      global $user;
      //npa($user);
      
      $checkError = false;
      
      //Check that the logged-in user matches the user who owns the order
      if( (int)$order->uid != (int)$user->uid){
      	$checkError = true;
      	//transaction user does not match order user
      	//print('transaction user does not match order user');
      	
      	watchdog('payfast', 
	'The user who landed on the order completion page was not the user who checked out the order. 
	PMT Token: '.$_GET['pt'].' | Order Number: '.$data['m_payment_id'].' | Payfast Transaction ID: '.$data['pf_payment_id'] );

        $return = '<p>ERROR: It appears you did not check out this order. You may <a href="/cart">try again.</a></p>';
        return $return;
        
      }
      
      //check that the amount paid is the same as the order total
      if( (int)$data[amount_gross] != (int)$order->order_total ){
      	$checkError = true;
      	
      	watchdog('payfast', 
        'The amount paid does not match the order amount. 
        PMT Token: '.$_GET['pt'].' | Order Number: '.$data['m_payment_id'].' | Payfast Transaction ID: '.$data['pf_payment_id'] );

        $return = '<p>ERROR: It appears the amount you paid is not the correct order amount. 
        Please <a href="/contact-us">contact us</a> with your email address and username.</p>';

        return $return;
      }
      
      //check that the order status is: "in_checkout"
      if($order->order_status != 'in_checkout'){
      	$checkError = true;
      	
      	watchdog('payfast', 
        'The order status is incorrect. PMT Token: '.$_GET['pt'].' | Order Number: '.$data['m_payment_id'].' | Payfast Transaction ID: '.$data['pf_payment_id'] );

        $return = '<p>ERROR: This order may have already been checked out or cancelled. Please <a href="/contact-us">contact us</a> with your email address and username.</p>';

        return $return;
      }

      // TODO: Hmm... a global?      
      global $payfastSuccess;
      $payfastSuccess = 1;

      // Otherwise just show order complete
      $output = uc_cart_complete_sale($order, variable_get('uc_new_customer_login', false));
      return $output;
    }
    
    // Close socket if successfully opened
    if($socket) {
      fclose($socket);
    }
  } else {
    //TODO: what is appropriate here?
  }

  drupal_goto("cart");
}

function uc_payfast_cancelled() {
	return '<p>You cancelled the payment. You may <a href="/cart">try again</a>.</p>';
}
